#ifndef ArduinoComponent_h
#define ArduinoComponent_h

/**@brief clase madre arduino component. */
class ArduinoComponent 
{
private:
	/**@brief atributo correspondiente al pin donde se conecta el componente. */
	int pin;
	/**@brief atributo pin auxiliar para componentes con ms una conexin a pines. */
	int aux_pin;
	/**@brief atributo correspondiente al modo de conexin con el pin, este puede ser OUTPUT o INPUT. */
	int mode;
	/**@brief atributo correspondiente al modo de conexin con el pin auxiliar, este puede ser OUTPUT o INPUT. */
	int mode_aux_pin;
public:
	/**@brief constructor por defecto clase arduino component. */
	ArduinoComponent();
	/**@brief destructor clase arduino component. */
	~ArduinoComponent();
	/**@brief metodo que devuelve el pin al que el componente se conecta. */
	int get_pin();
	/**@brief metodo que devuelve el pin auxiliar al que el componente se conecta. */
	int get_aux_pin();
	/**@brief metodo que devuelve el modo de conexin del pin. */
	int get_mode();
	/**@brief metodo que devuelve el modo de conexin del pin auxiliar. */
	int get_aux_mode();
protected:
	/**@brief metodo que establece el pin al que el componente se conecta. 
	*@param Pin entero correspondiente al pin.
	*/
	void set_pin(int Pin);
	/**@brief metodo que establece el modo de conexion con el pin.
	*@param Mode entero correspondiente al Modo.
	*/
	void set_mode(int Mode);
	/**@brief metodo que establece el pin auxiliar al que el componente se conecta.
	*@param Pin entero correspondiente al pin auxiliar.
	*/
	void set_aux_pin(int Pin);
	/**@brief metodo que establece el modo de conexion con el pin auxiliar.
	*@param Mode entero correspondiente al Modo.
	*/
	void set_mode_aux(int Mode);
};

#endif