#include "Bicho.h"
#include "Motor.h"
#include "ImpactSensor.h"
#include "LigthSensor.h"
//#include "UltrasonicSensor.h"
#include <Servo.h>
#include <Arduino.h>

Bicho::Bicho()
{
	motores[0] = new Motor(motor_r_e, motor_r_s);
	motores[1] = new Motor(motor_l_e, motor_l_s);
	AntenaDer = new ImpactSensor(RIGHT_ANT);
	AntenaIzq = new ImpactSensor(LEFT_ANT);
	//SensorUltrasonico = new UltrasonicSensor(TRIG_, ECHO_);
	SensorLuzIzq = new LigthSensor(SENSOR_LIGHT_IZQ);
	SensorLuzCentro = new LigthSensor(SENSOR_LIGHT);
	SensorLuzDer = new LigthSensor(SENSOR_LIGHT_DER);
	Neck = new Servo();
	Neck-> attach(NECK);
	Neck-> write(90);
}
Bicho::~Bicho()
{
	delete[] motores;
	delete SensorLuzCentro;
	delete SensorLuzDer;
	delete SensorLuzIzq;
	//delete SensorUltrasonico;
	delete Neck;
	delete AntenaDer;
	delete AntenaIzq;
}
void Bicho::motor_run(int motor_index, int vel)
{
	motores[motor_index]->Dwrite(LOW);
	if (abs(vel) > 5) {
		if (vel>0) {
			motores[motor_index]->Dwrite_Aux(LOW);
		}
		else {
			motores[motor_index]->Dwrite_Aux(HIGH);
		}

		motores[motor_index]->AWrite(abs(vel));
	}
	else { //Stop
		motores[motor_index]->Dwrite(LOW);
		motores[motor_index]->Dwrite_Aux(LOW);
	}
}

void Bicho::rbt_move(int spd_x, int spd_y)
{
	int motor_vel[] = { 0,0 };
	int velocity[] = { map(spd_x, -512, 511, -255,255),map(spd_y, -512, 511, -255,255) };

	if (abs(velocity[1]) > 105) {    // Y component Si se desplaza
		motor_vel[0] = velocity[1];///porque repite 1??
		motor_vel[1] = velocity[1];
		int motor_aux = map(velocity[0], -255, 255, -abs(velocity[1]), abs(velocity[1])); /// "velocidad" auxiliar?
		if (velocity[0] > 0) {        // X component  Si gira derecha
			if (velocity[1] > 0) { //I cuadrante
				motor_vel[r_motor] = motor_vel[r_motor] - motor_aux;
			}
			else {                 //IV cuadrante
				motor_vel[r_motor] = motor_vel[r_motor] + motor_aux;
			}
		}//if Right

		else if (velocity[0] < 0) { // X component  Si gira izquiera
			if (velocity[1] > 0) { //II cuadrante
				motor_vel[l_motor] = motor_vel[l_motor] - abs(motor_aux);
			}
			else {                //III cuadrante
				motor_vel[l_motor] = motor_vel[l_motor] + abs(motor_aux);
			}
		}//if Left
		motor_run(l_motor, motor_vel[l_motor]);
		motor_run(r_motor, motor_vel[r_motor]);


	}
	else if (abs(velocity[0]) > 5) {     //gira sobre su eje
		motor_run(l_motor, velocity[0]);
		motor_run(r_motor, -velocity[0]);
	}
	else {
		motor_run(l_motor, 0);
		motor_run(r_motor, 0);
	}
}

/*void Bicho::dis_thresh(byte dCM)
{
	int u_dist = SensorUltrasonico->dist() - dCM;
	if (abs(u_dist) > 3) {
		if (u_dist>0) {
			rbt_move(0, velt);
			delay(50);
		}
		else {
			rbt_move(0, -velt);
			delay(50);
		}
	}
	else {
		rbt_move(0, 0);
	}
}*/

void Bicho::nk_rotate(byte angle)
{
	Neck->write(angle);
}

void Bicho::rbt_ant()
{

	if (AntenaIzq->DRead() == LOW && AntenaDer->DRead() == LOW) {
		rbt_move(0, 350);
		Serial.println("avanzando");
	}

	if (r_crash > 4 || l_crash > 4) {
		rbt_move(0, -400);
		delay(200);
		if (r_crash > 4) {
			delay(300);
			rbt_move(-350, 0);
			delay(150);
		}
		else {
			rbt_move(0, -450);
			delay(300);
			rbt_move(350, 0);
		}
		delay(100);
		r_crash = 0; l_crash = 0;
		ant_crash_time = millis();
		Serial.println("HUBO choques sucesivos");

	}
	else if (AntenaIzq->DRead() == HIGH && AntenaDer->DRead() == HIGH) { //Dos apretadas
		rbt_move(0, -400);
		Serial.println("Atrs");
		if (t_turn) {
			rbt_move(200, 0);
		}
		else {
			rbt_move(-200, 0);
		}
		t_turn = !t_turn;
	}
	else if (AntenaIzq->DRead() == LOW && AntenaDer->DRead() == HIGH) { //Derecha apretada
		rbt_move(0, -300);
		delay(80);
		rbt_move(-300, 0);
		Serial.println("Toco Derecha");
		r_crash = r_crash + 1;
		ant_crash_time = millis();

	}
	else if (AntenaIzq->DRead() == HIGH && AntenaDer->DRead() == LOW) { //Izquierda apretada
		rbt_move(0, -300);
		delay(80);
		rbt_move(300, 0);
		Serial.println("Toco Izquierda");
		l_crash = l_crash + 1;
		ant_crash_time = millis();
	}
	delay(100);

	if (millis() - ant_crash_time > 2000) {
		ant_crash_time = millis();
		r_crash = 0; l_crash = 0;
		Serial.println("sin choques sucesivos");
	}
}

int Bicho::readRightAnt(){
	return AntenaDer->DRead();
}

int Bicho::readLeftAnt(){
	return AntenaIzq->DRead();
}

int Bicho::readLeftLight(){
	return SensorLuzIzq->readLight();
}

int Bicho::readCenterLight(){
	return SensorLuzCentro->readLight();
}

int Bicho::readRightLight(){
	return SensorLuzDer->readLight();
}