#pragma once
#ifndef Digital_h
#define Digital_h
#include "Sensor.h"
/**@brief clase Digital, esta hereda de Sensor. */
class Digital: public Sensor
{
public:
	Digital();
	/**@brief constructor de la clase, este hace uso del constructor de la clase Sensor.
	*@param Pin entero correspondiente al pin, este se entrega al constructor de Sensor.
	*/
	Digital(int Pin): Sensor(Pin) {};
	/**@brief constructor de la clase para sensores digitales con ms de una conexion a pines,
	*este hace uso del constructor de la clase Sensor.
	*@param Pin1 entero correspondiente al pin principal.
	*@param Pin2 entero correspondiente al pin auxiliar.
	*/
	Digital(int Pin1, int Pin2): Sensor(Pin1, Pin2) {};
	/**@brief metodo que que ejecuta la funcion digitalWrite.
	*@param valor correspone al bit entregado al pin.
	*/
	void DWrite(int valor);
	/**@brief metodo que que ejecuta la funcion digitalWrite.
	*@param valor corresponde al bit entregado al pin auxiliar.
	*/
	void DWrite_Aux(int valor);
	/**@brief metodo que ejecuta la funcion digitalRead.
	*@return int retorna el valor leido
	*/
	int DRead();
};
#endif