#include <Arduino.h>
#include "Iroh.h"

Iroh::~Iroh()
{
	delete[] motores;
	delete SensorLuzCentro;
	delete SensorLuzDer;
	delete SensorLuzIzq;
//	delete SensorUltrasonico;
	delete Neck;
	delete AntenaDer;
	delete AntenaIzq;
}

void Iroh::retroceder(int vel)
{
	if (Estado != Retrocede) {
		detenerse();
		Estado = Retrocede;
	}
	motor_run(r_motor, -1*vel);
	motor_run(l_motor, -1 * vel);//255 - vel?
}

void Iroh::retroceder(int velIzq, int velDer)
{
	if (Estado != Retrocede_DIF) {
		detenerse();
		Estado = Retrocede_DIF;
	}
	motor_run(r_motor, -1 * velDer);
	motor_run(l_motor, -1 * velIzq);//255 - vel?
}

void Iroh::avanzar(int vel)
{

	if (Estado != Avanza) {
		detenerse();
		Estado = Avanza;
	}
	motor_run(r_motor, vel);
	motor_run(l_motor, vel);//255 - vel?
}

void Iroh::avanzar(int velIzq, int velDer)
{

	if (Estado != Avanza_DIF) {
		detenerse();
		Estado = Avanza_DIF;
	}
	motor_run(r_motor, velDer);
	motor_run(l_motor, velIzq);
}

void Iroh::detenerse()
{
	motor_run(r_motor, 0);
	motor_run(l_motor, 0);
	delay(70);
	Estado = Detenido;
}

void Iroh::girarDerecha(int vel)
{
	if (Estado != Gira_Derecha) {
		detenerse();
		Estado = Gira_Derecha;
	}
	motor_run(r_motor, -vel);
	motor_run(l_motor, vel);
}

void Iroh::girarIzquierda(int vel)
{
	if (Estado != Gira_Izquierda) {
		detenerse();
		Estado = Gira_Izquierda;
	}
	motor_run(r_motor, vel);
	motor_run(l_motor, -vel);
}

void Iroh::inicializarMovimientoRobot()
{
}

void Iroh::inicializarCabezaRobot()
{
}

void Iroh::inicializarSensoresRobot()
{
}

void Iroh::moverServoYaw(int pos)
{
	Neck->write(pos);
}

int Iroh::leerSensorLineaIzquierdo()
{
	return SensorLuzIzq->ARead();
}

int Iroh::leerSensorLineaCentral()
{
	return SensorLuzCentro->ARead();
}

int Iroh::leerSensorLineaDerecho()
{
	return SensorLuzDer->ARead();
}

int Iroh::leerSensorObstaculoIzquierdo()
{
	return AntenaIzq->DRead();
}

int Iroh::leerSensorObstaculoDerecho()
{
	return AntenaDer->DRead();
}

/*int Iroh::leerDistanciaSonar()
{
	return SensorUltrasonico->dist();
}*/

void Iroh::finPrograma()
{
	detenerse();
	while (1) {

	}

}

void Iroh::pausa(int tiempo)
{
	delay(tiempo);
}
